#include "svt.h"

#define SPEEDSTEP 100

int LastKeyState;
int MotorSpeed = 5000;

void Start(){
  OpenGraphics();
  OpenMotors();
}

void End(){
  CloseGraphics();
  CloseMotors();
}


void display(int keyState){
  ClearScreen();
  DrawText( 5, 0, "Spd: %d", MotorSpeed ); //show motor speed
  int y=15; // variable to increment text display downward
  if(keyState&KEY_LEFT_BACK){ // if bit in "keyState" associated with "KEY_LEFT_BACK" is high
    SetLeftMotor(-MotorSpeed); // set motor speed
  }
  if(keyState&KEY_LEFT_FORWARD){
    SetLeftMotor(+MotorSpeed);
  }
  if(keyState&KEY_RIGHT_BACK){
    SetRightMotor(-MotorSpeed);
  }
  if(keyState&KEY_RIGHT_FORWARD){
    SetRightMotor(MotorSpeed);
  }
  if(keyState&KEY_RUN){
    DrawText( 5, y, "GO" );
    y=y+15;
  }
  if(keyState&KEY_INPUT2){
    MotorSpeed+=SPEEDSTEP;
  }
  if(keyState&KEY_MENU){
    MotorSpeed-=SPEEDSTEP;
  }
  if(keyState==0){
    //DrawText( 5, 30, "NONE PRESSED" );
  }
  Show();
}


bool Run(){
  int KeyState = 0;
  while( !(KeyState&KEY_HOME)){
    KeyState = GetRemoteKeys();// load button states
    // if buttons are in new state...
    if(LastKeyState!=KeyState){
      display(KeyState);// show the names of pressed buttons
      // stop motors if not commanded
      if( !(KeyState&(KEY_LEFT_FORWARD | KEY_LEFT_BACK))){
        SetLeftMotor(0);
      }
      if( !(KeyState&(KEY_RIGHT_FORWARD | KEY_RIGHT_BACK))){
        SetRightMotor(0);
      }
      LastKeyState=KeyState;// update the old state to the new
    }
    Sleep(100); //no need to keep the radio working constantly.
  }
  return false; // exit program
}

